function results = KFE_dyn(parameters,results,g0)
% This codes computes the KFE
I    = parameters.I;                % numer of points
J    = parameters.J;                % numer of points
dt   = parameters.dt; 
N    = parameters.N;         % number of time periods
eta  = parameters.eta;
da   = results.da;
dz   = results.dz;

g        = zeros(I,J,N);          % Distribution
g(:,:,1)  = g0;                 % Initial value

i_fix   = 1;

for n=1:N-1
    A  = results.A_n{n};
    AT = A';
    
    gg                 = g(:,:,n);
    gg_stacked         = reshape(gg,I*J,1);

 %     Implicit method in Updating Distribution.
      gg_stacked(i_fix)  = gg_stacked(i_fix) + dt* eta /da /dz;  %Injection of new agents
      gg_stacked         = (speye(I*J) - AT*dt) \ gg_stacked;        
  
      
%     Explicit method in Updating Distribution.
%     gg_stacked         = (speye(I*J)  + dt * AT)* gg_stacked;   
%     gg_stacked(i_fix)  = gg_stacked(i_fix) + dt* eta /da /dz;  %Injection of new agents   
%     gg_stacked         = max(gg_stacked,0);
%     g_sum              = gg_stacked'*ones(I*J,1)*da*dz;
%     gg_stacked         = gg_stacked./g_sum;
    
    gg_next     = reshape(gg_stacked,I,J);
    g(:,:,n+1)  = gg_next;
end

% g(:,:,N)  = results.g; % We impose the terminal value equals the SS check

results.g_n  = g;






