function  results = equilibrium_dyn(parameters, results,g0,lambda_n)
%Computes the transitional dynamics
N       = parameters.N;
maxitK = parameters.maxitK;
critK  = parameters.critK;
relax  = parameters.relax;  
   
da   = results.da;
dz   = results.dz;
a    = results.a;

%First guess of capital
K_n               =  results.K * ones(1,N);
S_n               =  zeros(1,N);



for it=1:maxitK
    results = HJB_dyn(parameters,results,K_n,lambda_n);
    results = KFE_dyn(parameters,results,g0);
    for n=1:N
        S_n(n) = sum(results.g_n(:,:,n)'*a*da*dz);
    end
    if max(abs(K_n-S_n))<critK
        break
    end
    K_n = relax*K_n +(1-relax)*S_n;
         
    disp('iteration = ')
    disp(it)
    disp('error =')
    disp(max(abs(K_n-S_n)))
end

if n == maxitK
    disp('Equilibrium NOT Converged, ERROR ')
end
    
results.K_n = K_n;